## mkswu-7.8-r0.tar

=== Makefile ===
PREFIX ?= /usr
BIN = $(PREFIX)/bin
SHARE = $(PREFIX)/share/mkswu
LOCALEDIR = $(PREFIX)/share/locale
LIBEXEC = $(PREFIX)/libexec/mkswu
BASH_COMPLETION_DIR = $(PREFIX)/share/bash-completion/completions

# could be possible to handle wildcard of languages later
# https://stackoverflow.com/a/40881718
l = ja
translations = $(wildcard po/$(l)/*.po)
locales = $(patsubst po/$(l)/%.po,locale/$(l)/LC_MESSAGES/%.mo,$(translations))

install_scripts = $(wildcard scripts/*.sh) $(wildcard scripts/podman_*) $(wildcard scripts/install_*)
install_docs = $(wildcard docs/*.md)
install_docs_html = $(patsubst docs/%.md,docs/%.html,$(install_docs))


.PHONY: all install install_swupdate check clean locales doc

all: locales

locales: $(locales)

doc: $(install_docs_html)

clean:
	rm -rf tests/out
	@# tests input
	rm -f tests/zoo/* tests/mkswu-aes.conf tests/swupdate.aes-key
	rm -f examples/nginx_start.tar imx-boot_armadillo_x2 examples/linux-at-5.10.9-r3.apk
	rm -rf examples/kernel
	rm -f docs/*.html


po/mkswu.pot: mkswu examples/enable_sshd.desc examples/hawkbit_register.desc
	./po/update.sh $@ $^

po/mkimage.pot: mkimage.sh
	./po/update.sh $@ $^

po/hawkbit_setup_container.pot: hawkbit-compose/setup_container.sh
	./po/update.sh $@ $^

po/mkswu_kernel_update_plain.pot: examples/kernel_update_plain.install.sh
	./po/update.sh $@ $^

po/$(l)/%.po: po/%.pot
	msgmerge --no-wrap -o $@ $@ $<

locale/$(l)/LC_MESSAGES/%.mo: po/$(l)/%.po
	@# restandardize po file formatting
	msgmerge --no-wrap -o $< $< $<
	@if grep -qx "#, fuzzy" $<; then \
		echo "$< has had fuzzy updates, please fix before updating!"; \
		false; \
	fi
	@if ! [ -d locale/$(l)/LC_MESSAGES ]; then \
		mkdir -p locale/$(l)/LC_MESSAGES; \
	fi
	msgfmt -o $@ $<

docs/%.html: docs/%.md
	pandoc -s $< -o $@

check:
	./tests/run.sh

TAG ?= $(subst -,.,$(shell git describe --tags 2>/dev/null || cat .version))

TARNAME = mkswu_$(TAG)

dist: all
	@if ! [ -e .git ]; then \
		echo "make dist can only run within git directory"; \
		false; \
	fi
	@git update-index --refresh
	@if ! git diff-index --ignore-submodules=untracked --quiet HEAD; then \
		echo "git index is not clean: please run make clean and check submodules"; \
		false; \
	fi
	echo $(TAG) > .version
	{ git ls-files --recurse-submodules; printf "%s\n" ".version" "locale"; } | \
		tar -caJf $(TARNAME).orig.tar.xz --xform "s:^:$(TARNAME)/:S" --verbatim-files-from -T-
	@mkdir -p hawkbit-compose/locale/$(l)/LC_MESSAGES
	@cp -a locale/$(l)/LC_MESSAGES/hawkbit_setup_container.mo \
		hawkbit-compose/locale/$(l)/LC_MESSAGES/hawkbit_setup_container.mo
	{ git ls-files hawkbit-compose; echo hawkbit-compose/locale; } | \
		tar -caJf hawkbit-compose-$(TAG).tar.xz --xform "s:^hawkbit-compose:hawkbit-compose-$(TAG):S" --verbatim-files-from -T-

install: install_mkswu install_examples install_locales install_html

install_mkswu:
	install -D -t $(DESTDIR)$(BIN) mkswu hawkbit_push_update
	sed -i -e "s/MKSWU_VERSION=\"\"/MKSWU_VERSION=\"$(TAG)\"/" $(DESTDIR)$(BIN)/mkswu
	install -D -t $(DESTDIR)$(BIN) podman_partial_image
	install -D -m 0644 -t $(DESTDIR)$(SHARE) mkswu.conf.defaults
	install -D -m 0644 -t $(DESTDIR)$(SHARE) swupdate-onetime-public.key
	install -D -m 0644 -t $(DESTDIR)$(SHARE) swupdate-onetime-public.pem
	install -d $(DESTDIR)$(SHARE)/certs
	install -D -m 0644 -t $(DESTDIR)$(SHARE)/certs certs/atmark*.pem
	install -D -m 0644 -t $(DESTDIR)$(BASH_COMPLETION_DIR) \
		bash_completion.d/mkswu bash_completion.d/hawkbit_push_update \
		bash_completion.d/podman_partial_image
	install -D -t $(DESTDIR)$(SHARE) scripts_pre.sh scripts_post.sh
	install -d $(DESTDIR)$(SHARE)/scripts
	@# use cp instead of install to preserve executable mode
	cp -t $(DESTDIR)$(SHARE)/scripts $(install_scripts)

install_examples:
	install -d $(DESTDIR)$(SHARE)/examples
	cp -t $(DESTDIR)$(SHARE)/examples \
		examples/*.desc examples/*.sh
	install -d $(DESTDIR)$(SHARE)/examples/nginx_start/etc/atmark/containers
	cp -t $(DESTDIR)$(SHARE)/examples/nginx_start/etc/atmark/containers \
		examples/nginx_start/etc/atmark/containers/nginx.conf
	install -d $(DESTDIR)$(SHARE)/examples/enable_sshd/root/.ssh
	cp -t $(DESTDIR)$(SHARE)/examples/enable_sshd/root/.ssh \
		examples/enable_sshd/root/.ssh/authorized_keys
	install -d $(DESTDIR)$(SHARE)/examples/uboot_env
	cp -t $(DESTDIR)$(SHARE)/examples/uboot_env examples/uboot_env/bootdelay
	install -d $(DESTDIR)$(SHARE)/examples/armadillo-twin
	cp -t $(DESTDIR)$(SHARE)/examples/armadillo-twin \
		examples/armadillo-twin/*.desc examples/armadillo-twin/*.sh
	install -d $(DESTDIR)$(SHARE)/examples/node-red
	cp -t $(DESTDIR)$(SHARE)/examples/node-red \
		examples/node-red/*.desc

install_locales: locales
	install -D -m 0644 -t $(DESTDIR)$(LOCALEDIR)/$(l)/LC_MESSAGES locale/ja/LC_MESSAGES/mkswu.mo

install_html: $(install_docs_html)
	install -d $(DESTDIR)$(SHARE)/docs
	cp -t $(DESTDIR)$(SHARE)/docs $(install_docs_html)

# this target is not part of normal install
install_swupdate:
	install -d $(DESTDIR)$(LIBEXEC)
	cp -t $(DESTDIR)$(LIBEXEC) $(install_scripts)
	cp scripts_post.sh $(DESTDIR)$(LIBEXEC)/post.sh
	# remove self-decompress
	sed -e '/BEGIN_ARCHIVE/d' scripts_pre.sh > $(DESTDIR)$(LIBEXEC)/pre.sh
	chmod +x $(DESTDIR)$(LIBEXEC)/pre.sh
	# modify skip install hook
	sed -i -e 's/DEBUG_SKIP_SCRIPTS/DEBUG_SKIP_VENDORED_SCRIPTS/' $(DESTDIR)$(LIBEXEC)/common.sh
	# modify scripts base directory
	sed -i -e 's:^SCRIPTSDIR=.*:SCRIPTSDIR=$(LIBEXEC):' \
		-e 's/^MKSWU_TMP=.*/&-vendored/' \
		$(DESTDIR)$(LIBEXEC)/pre.sh \
		$(DESTDIR)$(LIBEXEC)/post.sh \
		$(DESTDIR)$(LIBEXEC)/cleanup.sh
	# record version
	echo "$(TAG)" > $(DESTDIR)$(LIBEXEC)/version

=== debian/changelog ===
mkswu (7.8) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Mon, 22 Sep 2025 10:01:44 +0900

mkswu (7.7.1) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Thu, 04 Sep 2025 12:26:24 +0900

mkswu (7.7) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Fri, 22 Aug 2025 13:07:25 +0900

mkswu (7.6.2) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Mon, 19 May 2025 13:15:25 +0900

mkswu (7.6.1) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Mon, 12 May 2025 10:30:42 +0900

mkswu (7.6) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Mon, 21 Apr 2025 14:38:30 +0900

mkswu (7.5) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Mon, 14 Apr 2025 13:20:39 +0900

mkswu (7.4) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Tue, 25 Mar 2025 09:56:35 +0900

mkswu (7.3.1) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Wed, 05 Mar 2025 10:37:38 +0900

mkswu (7.2) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Fri, 21 Feb 2025 10:29:29 +0900

mkswu (7.1) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Fri, 22 Nov 2024 16:35:53 +0900

mkswu (7.0) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Fri, 15 Nov 2024 15:04:05 +0900

mkswu (6.5) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Thu, 24 Oct 2024 17:48:14 +0900

mkswu (6.4) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Fri, 23 Aug 2024 15:24:22 +0900

mkswu (6.3) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Fri, 19 Jul 2024 09:42:56 +0900

mkswu (6.2.1) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Tue, 25 Jun 2024 08:51:58 +0900

mkswu (6.2) experimental; urgency=low

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Thu, 20 Jun 2024 13:43:21 +0900

mkswu (6.1) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Fri, 24 May 2024 10:20:27 +0900

mkswu (6.0) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Fri, 19 Apr 2024 09:19:31 +0900

mkswu (5.5) experimental; urgency=low

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Mon, 25 Mar 2024 15:20:06 +0900

mkswu (5.4.1) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Mon, 26 Feb 2024 15:29:50 +0900

mkswu (5.4) experimental; urgency=medium


 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Mon, 26 Feb 2024 10:41:43 +0900

mkswu (5.3) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Tue, 23 Jan 2024 13:06:13 +0900

mkswu (5.2.2) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Thu, 11 Jan 2024 17:43:56 +0900

mkswu (5.2.1) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Thu, 28 Dec 2023 10:26:47 +0900

mkswu (5.2) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Fri, 22 Dec 2023 15:58:34 +0900

mkswu (5.1) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Fri, 24 Nov 2023 09:04:41 +0900

mkswu (5.0.1) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Thu, 26 Oct 2023 14:42:44 +0900

mkswu (5.0) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Mon, 23 Oct 2023 14:28:43 +0900

mkswu (4.15.1) experimental; urgency=medium

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Tue, 26 Sep 2023 12:35:43 +0900

mkswu (4.15) experimental; urgency=low

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Fri, 22 Sep 2023 12:48:39 +0900

mkswu (4.14.1) experimental; urgency=low

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Thu, 27 Jul 2023 11:48:44 +0900

mkswu (4.14) experimental; urgency=low

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Tue, 25 Jul 2023 10:36:10 +0900

mkswu (4.13) experimental; urgency=low

  * upstream update (see changelog)

 -- Dominique Martinet <dominique.martinet@atmark-techno.com>  Tue, 27 Jun 2023 09:55:09 +0900

mkswu (4.12-1) experimental; urgency=low



=== APKBUILD ===
# Maintainer: Dominique Martinet <dominique.martinet@atmark-techno.com>
pkgname=mkswu
pkgver=7.8
pkgrel=0
_ref="$pkgver"
pkgdesc="Helper scripts for swupdate"
url="https://github.com/atmark-techno/mkswu"
arch="noarch"
license="MIT"
depends="busybox findmnt lsblk"
depends_lang="gettext"
makedepends="gettext"
checkdepends="bash coreutils cpio zstd tar"
source="mkswu-7.8.tar.gz"
subpackages="
	$pkgname-lang
	$pkgname-bash-completion
	$pkgname-doc
	$pkgname-swupdate
	"

build() {
	echo "$pkgver" > .version
}

check() {
	./tests/run.sh
}

package() {
	depends="$depends coreutils cpio zstd tar"
	# pandoc is not available on armv7 so we skip installing html,
	# using individual targets instead.
	DESTDIR="$pkgdir" make install_mkswu install_examples \
		install_locales
	# podman_partial_image is installed in abos-base, remove it here
	rm -f "$pkgdir/usr/bin/podman_partial_image"
}

doc() {
	amove /usr/share/mkswu/examples
	# re-move examples/initial_setup.desc back to main package
	# for mkswu --init
	mkdir -p "$pkgdir/usr/share/mkswu/examples"
	mv "$subpkgdir/usr/share/mkswu/examples/initial_setup.desc" \
		"$pkgdir/usr/share/mkswu/examples/"
}

swupdate() {
	cd "$builddir"
	DESTDIR="$subpkgdir" make install_swupdate
	# add $pkgrel at the end of scripts version so development versions
	# of mkswu (git describe "tag-x-hash") are properly considered
	sed -i -e "s/.*/&-$pkgrel/" "$subpkgdir/usr/libexec/mkswu/version"
}

sha512sums="
7eaf3a533171858cb7de4573493140cd676afee2e5de229b4a95fe34f80db8cefd1478013c551cb260d36941704ca9438e003ca6a76bc4f108f1cef0913d658e  mkswu-7.8.tar.gz
"

=== debian/control ===
Source: mkswu
Section: misc
Priority: optional
Homepage: https://github.com/atmark-techno/swupdate-mkimage
Standards-Version: 3.9.2
Maintainer: Dominique Martinet <dominique.martinet@atmark-techno.com>
Build-Depends: debhelper-compat (= 12), gettext, pandoc

Package: mkswu
Depends:
 cpio,
 zstd,
 jq,
 xxd,
 gawk,
 ${misc:Depends}
Architecture: all
Description: build SWU images for armadillo base OS
 scripts for building armadillo base OS updates
 .
 Can install OS updates, containers or arbitrary files/commands with
 the generated images.
